/* staggered dimer (J-J') model with spiral model state (see Sven E. Krueger)
   written by Sven Krueger, see stag_spiral.ccm
*/

#define _USR_PARAMETER_ "bonds1_J'=D bonds2_J=1"
double usr_parameter(int bonds, double alpha)
{
  /* add your model specifique parameter here! H=sum_i u(i,alpha)*H_i */
  //  d1 * H1 + d2 * H2 + d3 * H3 + ...
  if (bonds==1) return alpha;
  return 1.0;
}

#define UseAlpha 1   // number of parameters in alpha[]
#define StartAlpha    0.2
#define StepAlpha     0.02
#define SearchAlphaMin 0 // 0=startAlpha_only or 1=fix_steps, 2=dynamic_search

double usr_angle(int bond, int term13, double *alpha, int numalpha)
{ 
  double mult = 0.0;  // default for term13 = {10,11,12,13}
  double phi;
  if (bond==1) phi = M_PI + 3*alpha[0];  // J'  bond
  else         phi = M_PI +   alpha[0];  // J=1 bond
  switch (term13) {
    case 1: mult=       cos(phi);    break; // s^z s^z 
    case 2: mult=  -0.5*sin(phi);    break; // s^z s^+ 
    case 3: mult=  -0.5*sin(phi);    break; // s^z s^- 
    case 4: mult=   0.5*sin(phi);    break; // s^+ s^z
    case 5: mult=   0.5*sin(phi);    break; // s^- s^z
    case 6: mult= 0.25*(cos(phi)+1); break; // s^+ s^-
    case 7: mult= 0.25*(cos(phi)+1); break; // s^- s^+
    case 8: mult= 0.25*(cos(phi)-1); break; // s^+ s^+
    case 9: mult= 0.25*(cos(phi)-1); break; // s^- s^-
  }
  return mult;
}
